% vOH
% *******************************************************
%    << OLG : OVER LAPPING GENERATIONS MODEL >>    
% ********************************************************

clear all

%---------------------
%@p[^ݒ
%---------------------

global RHO GAMMA IRET IDIE GG EPSI RDEP TW TR TC SDRT GEN A
global ITER1 ITER2 ISE ITRTE KOUNT DELTA;
global SL SC SA XNN1; 

RHO=0.01;  % ԑID
GAMMA=0.5; % َ_Ԃ̑ւ̒e͐̋t
IRET=44;   % ސE
IDIE=65;   % U
GG=0.02;   % Zpi
EPSI=0.3;  % {z
RDEP=0.05; % p
TW=0.20;   % 
TR=0.05;   % {ې
TC=0.10;   % 
RGC=0.15;  % {GDP䗦
SDRT=0.5;  % s
GEN=1;     % K
A=1;       % oϋK
RGSP=0.25; % NɕS䗦
RPR=0.40;  % vCXg
RFIX=0;    % NŒ蕔
RPP=0.20;  % Nی
TWP=0.10;  % Nې

ITER1=250;        % vZIN
ITER2=500;        % KvvZIN
ISE=100;          % ڍs̊JnN
ITRTE=200000;     % 񐔏
KOUNT=0;          % 
DELTA=0.99999999; % vZx


%------------------------
%@Ԑl̐ݒ
%------------------------
XNN1=  0.01;  % (initial steady state)̐l
XNN2= -0.01;  % ŏI(final steady state)̐l

%@
for I=1:ISE-1;
    XNINT(I)=XNN1;
end
%@ڍs
for I=ISE:ITER1;
    XNINT(I)=XNN1+(XNN2-XNN1)*(I-ISE)/(ITER1-ISE);
end
%@ŏI
for I=ITER1+1:ITER2;
    XNINT(I)=XNN2;
end

%-----------------------------------
%@NʘJ̐ݒ
%  H22Nw\{x萄v
%-----------------------------------
for J=1:IRET;
    SL(J)=1.417+0.1488*J-0.0027*J^2;
end
for J=IRET+1:IDIE;
    SL(J)=0;
end


%---------------------
%@Ԃ̌vZ
%---------------------

XKL0=4; % Cӂ̏l
SKL1=STEADY(XKL0); % Ԃ̎{J䗦


%-----------------------------------------
%@CEubNiߓnEڍšvZj
%-----------------------------------------
%@{J䗦Aŗ̏n̐ݒ
OLDX=zeros(ITER1,2);
for I=ISE:ITER1;
    OLDX(I,1)=SKL1;
    OLDX(I,2)=TC;
end

%*****************************
%@[vJn
%*****************************
%@덷̏ݒ
DIF=1;
while ( KOUNT<ITRTE ) && ( DIF>0.0001 );
  %---------------------------------------------------------------
  %@vZQ̕ϐi{J䗦Aŗj̏l̐ݒ
  %---------------------------------------------------------------
  for I=1:ISE-1;    
      XKL(I)=SKL1;
      XTC(I)=TC;
  end  
  
  for I=ISE:ITER1;
      XKL(I)=OLDX(I,1);
      XTC(I)=OLDX(I,2);
  end
  
  for I=ITER1+1:ITER2;
      XKL(I)=XKL(ITER1);
      XTC(I)=XTC(ITER1);
  end
       
  %--------------------
  %@YvfǐvZ
  %--------------------
  for I=1:ITER2;
      W(I)=(1-EPSI)*A*XKL(I)^EPSI;
      R(I)=EPSI*A*XKL(I)^(EPSI-1)-RDEP;
  end
  
  %-----------------
  %@ϐ̊ȗ\
  %-----------------
  for I=1:ITER2;
      RN(I)=R(I)*(1-TR);
  end
  
  %-------------------
  %@ߓňvZ
  %-------------------
  
  %**********************************************
  %@Ԃ̉ŋ܂鎑YAňvZ
  %**********************************************
  AA=zeros(ITER1,IDIE);
  C=zeros(ITER1,IDIE);
  for MM=1:ISE-1;
      for J=1:IDIE;
          AA(ISE-MM,J)=SA(J)*(1+GG)^(ISE-MM);
          C(ISE-MM,J)=SC(J)*(1+GG)^(ISE-MM);
      end      
  end

  %**************************************
  %@ISEN݂̉lɕϊ邽߂̕ϐ
  %**************************************
  SRR(2)=1;
  for M=3:IDIE;
      SRR(M)=SRR(M-1)/(1+RN(ISE+M-2));
  end

  %*****************************
  %@U(ISEN݂̉lj
  %*****************************
  %@ΘJ
  for J=2:IRET;
      SPDVW(J)=0;
      %  (ISE-J+1)ISENȍ~̒viISEN݂̉lj
      for JJ=0:IRET-J;
          SPDVW(J)=SPDVW(J)+W(ISE+JJ)*((1+GG)^(ISE+JJ))*(1-TW)*SL(J+JJ)*SRR(2+JJ);
      end
  end
  for J=2:IRET;
      %@(ISE-J+1)ISEN̎Y{ISENȍ~̒viISEN݂̉lj
      SPDVW(J)=SPDVW(J)+(1+RN(ISE))*AA(ISE-J+1,J-1);      
  end

  %@ފ
  for J=IRET+1:IDIE;
      SPDVW(J)=(1+RN(ISE))*AA(ISE-J+1,J-1);
  end

  %************
  %@U
  %************
  %@IC[iǰW̌vZ
  SRR1(2)=1;
  for M=3:IDIE;
      SRR1(M)=SRR1(M-1)*(((1+RN(ISE+M-2))/(1+RHO))^(1/GAMMA))*((1+XTC(ISE+M-3))/(1+XTC(ISE+M-2)))^(1/GAMMA);
  end
  
  for J=2:IDIE;
      SRR1(J)=SRR1(J)*(1+XTC(ISE+J-2));
  end
  
  %@W̐ςݏグAISEN݂̉lvZ
  for J=2:IDIE;
      JJ=IDIE+2-J;
      SPDVC(J)=0;
      %@
      for M=2:JJ;
          SPDVC(J)=SPDVC(J)+SRR1(M)*SRR(M);
      end
   end
  
  %@ISENɂȅ
  for J=2:IDIE;
      % (ISE-J+1)ISEN(Jj
      C(ISE-J+1,J)=SPDVW(J)/SPDVC(J);
  end
  
  %@(ISE+M)Nɂȅ
  for J=2:IDIE-1;
      JJ=IDIE-J;
      for M=1:JJ;
          % (ISE-J+1)(ISE+M)N(J+Mj
          C(ISE-J+1,J+M)=C(ISE-J+1,J+M-1)*((1+RN(ISE+M))/(1+RHO))^(1/GAMMA)*((1+XTC(ISE+M-1))/(1+XTC(ISE+M)))^(1/GAMMA);
      end
  end
  
  %************
  %  Yn
  %************
  for J=1:IDIE-1;
      JJ=IDIE-1-J;
      if J<IRET;
          for M=0:JJ;
              if M<IRET-J;
                  AA(ISE-J,J+1+M)=AA(ISE-J,J+M)*(1+RN(ISE+M))+W(ISE+M)*(1+GG)^(ISE+M)*SL(J+1+M)*(1-TW)-C(ISE-J,J+1+M)*(1+XTC(ISE+M));
              else
                  AA(ISE-J,J+1+M)=AA(ISE-J,J+M)*(1+RN(ISE+M))-C(ISE-J,J+1+M)*(1+XTC(ISE+M));
              end
          end
      else
          for M=0:JJ;
              AA(ISE-J,J+1+M)=AA(ISE-J,J+M)*(1+RN(ISE+M))-C(ISE-J,J+1+M)*(1+XTC(ISE+M));
          end
      end
  end
  
  %****************
  %  ߓnI
  %****************
  
  %-----------------
  %  ڍšvZ
  %-----------------
  
  %**************************************************
  %@I̐lPƂꍇ(I-IDIE-1)̐l
  %**************************************************
  for I=ISE:ITER1;
      XBRT(I)=1;
      for M=I-IDIE+2:I;
          XBRT(I)=XBRT(I)/(1+XNINT(M));
      end
  end
  
  %************
  %@Nx
  %************
  PP=zeros(ITER1,IDIE);
  for I=ISE:ITER1;
      for J=1:IRET;
          % IオJɎxی
          PP(I,J)=RPP*W(I+J-1)*(1+GG)^(I+J-1)*SL(J);
      end
  end
  
  %*************
  %  N
  %*************
  % ëގ_ł̉lɒ߂̕ϐ
  for I=ISE:ITER1;
      PDVP(I,IRET)=1;
      for J=1:IRET-1;
          JJ=IRET-J;
          PDVP(I,JJ)=PDVP(I,JJ+1)*(1+RN(I+JJ));
      end
  end
  
  %@NϒN󋋎̉lɊZ
  VPR=zeros(ITER1,IDIE);
  for I=ISE:ITER1;
      for J=1:IRET;
          VPR(I,IRET)=VPR(I,IRET)+PDVP(I,J)*W(I+J-1)*(1+GG)^(I+J-1)*SL(J)/IRET;
      end
      
      for J=IRET+1:IDIE;
          VPR(I,J)=VPR(I,J-1)*(1+RN(I+J-1));
      end
  end
  
  %  N
  PR=zeros(ITER1,IDIE);
  for I=ISE:ITER1;
      for J=IRET+1:IDIE;
          PR(I,J)=RFIX+RPR*VPR(I,J);   
      end
  end
  
  
  for I=ISE:ITER1;
      %******************
      %  ̌݉l
      %******************
      PDVW(I)=0;
      %  Iオ20+J΂̂Ƃ̕ϐ20+1Ύ_̌݉lɒϐ
      RR(I,1)=1;
      for J=2:IDIE;
          RR(I,J)=RR(I,J-1)/(1+RN(I+J-1));
      end
      
      %@
      for J=1:IRET;
          PDVW(I)=PDVW(I)+W(I+J-1)*(1+GG)^(I+J-1)*SL(J)*(1-TW)*RR(I,J);
      end
      
      %@ތ̔N
      for J=IRET+1:IDIE;
          PDVW(I)=PDVW(I)+PR(I,J)*(1-TWP)*RR(I,J);
      end

      %@ΘJ̔Nx
      for J=1:IRET;
          PDVW(I)=PDVW(I)-PP(I,J)*(1-TW)*RR(I,J);
      end

      %*********
      %  
      %*********
      PDVC(I)=0;
      RRC(I,1)=1;
      
      %@IC[̌Ẅꕔ
      for J=2:IDIE;
          RRC(I,J)=RRC(I,J-1)*(1+RN(I+J-1))^(1/GAMMA)*((1+XTC(I+J-2))/(1+XTC(I+J-1)))^(1/GAMMA);
      end
      
      for J=1:IDIE;
          PDVC(I)=PDVC(I)+(1+RHO)^((1-J)/GAMMA)*RRC(I,J)*RR(I,J)*(1+XTC(I+J-1));
      end
      
      %@1ڂ̏̌
      C(I,1)=PDVW(I)/PDVC(I);
      
      %  2ڈȍ~̗̏
      for J=2:IDIE;
          C(I,J)=C(I,1)*(1+RHO)^((1-J)/GAMMA)*RRC(I,J);
      end
  end
  
  for I=ISE:ITER1;
      %**************************
      %@Ȉ_̎Y
      %**************************
       AA(I,1)=W(I)*(1+GG)^I*SL(1)*(1-TW)-C(I,1)*(1+XTC(I))-(1-TW)*PP(I,1);
      %**************
      %@Y̗
      %**************
      for J=2:IDIE;
          if J<=IRET;
              AA(I,J)=AA(I,J-1)*(1+RN(I+J-1))+W(I+J-1)*(1+GG)^(I+J-1)*SL(J)*(1-TW)-C(I,J)*(1+XTC(I+J-1))+(1-TWP)*PR(I,J)-(1-TW)*PP(I,J);
          else
              AA(I,J)=AA(I,J-1)*(1+RN(I+J-1))-C(I,J)*(1+XTC(I+J-1))+(1-TWP)*PR(I,J)-(1-TW)*PP(I,J);
          end
      end      
  end
  

  %**************
  %@}Nϐ
  %**************
  %@I̐l
  for I=1:ITER2;
      GENP(I)=GEN;
      for J=1:I;
          GENP(I)=GENP(I)*(1+XNINT(J));
      end
  end
  
  %================
  %@NubN
  %================
  % z̍ɕS
  for I=ISE:ITER1;
      GENFIX(I)=0;
      for J=IRET+1:IDIE;
          GENFIX(I)=GENFIX(I)+RFIX*GENP(I-J+1);
      end
      
      GSP(I)=RGSP*GENFIX(I);
  end
  
  %@NیANtz
  for I=ISE:ITER1;
      AGPP(I)=0;
      AGPR(I)=0;
      for J=1:IRET;
          AGPP(I)=AGPP(I)+PP(I-J+1,J)*GENP(I-J+1);
      end
      for J=IRET+1:IDIE;
          AGPR(I)=AGPR(I)+PR(I-J+1,J)*GENP(I-J+1);
      end          
  end
    
  %@Nϗ
  FUND(ISE-1)=0;
  for I=ISE:ITER1;      
      FUND(I)=FUND(I-1)+AGPP(I)-AGPR(I)+GSP(I)+R(I)*(1-TR)*FUND(I-1);
  end  
    
  %===================
  %@NubNI
  %===================
  
  %@ԋZY
  for I=IDIE:ITER1;  
      PASET(I)=0;
      for J=1:IDIE-1;
          PASET(I)=PASET(I)+AA(I-J+1,J)*GENP(I-J+1);
      end  
  end
  
  %@}N  
  for I=IDIE:ITER1;
      AGC(I)=0;
      for J=1:IDIE;
          AGC(I)=AGC(I)+C(I-J+1,J)*GENP(I-J+1);
      end      
  end
  
  %@l֘AϐiΘJAސj
  for I=IDIE:ITER1;
      POP1(I)=0;
      POP2(I)=0;
      POP(I)=0;    
      for J=1:IRET;
          POP1(I)=POP1(I)+GENP(I-J+1);
      end
      
      for J=IRET+1:IDIE;
          POP2(I)=POP2(I)+GENP(I-J+1);
      end
      
      POP(I)=POP1(I)+POP2(I);
      SUP(I)=POP1(I)/POP2(I);    
  end
  
  %@}NJ
  
  for I=ISE:ITER2;
      AGL(I)=0;
      AGEL(I)=0;
      for J=1:IDIE;
          AGL(I)=AGL(I)+GENP(I-J+1)*SL(J);
          AGEL(I)=AGL(I)*(1+GG)^I;    
      end
  end  
  
  %@WvZY
  for I=1:ITER1;
      %@Y{
      CAP(I+1)=XKL(I+1)*AGEL(I+1);
      
      %@WvZY
      DFA(I)=CAP(I+1)/(1-SDRT);
  end
  
  %@ϐ
  for I=1:ISE-1
      %  Ic
      DEBT(I)=DFA(I)*SDRT;      
  end
  
  for I=2:ISE-1;
      %  s
      BOND(I)=(DFA(I)-DFA(I-1))*SDRT;
      %  
      RDEBT(I)=DEBT(I-1)*R(I);
  end
  
  for I=ISE:ITER1;
      DEBT(I)=(DFA(I)-DFA(I-1))*SDRT+DEBT(I-1);
      BOND(I)=(DFA(I)-DFA(I-1))*SDRT;
      RDEBT(I)=DEBT(I-1)*R(I);      
  end
  
  for I=ISE:ITER1;
      %  Y
      GDP(I)=A*XKL(I)^EPSI*AGEL(I);
      
      %@{
      GC(I)=RGC*GDP(I);
      
      %@{xo
      GCAG(I)=GC(I)+GSP(I); 
      
      %@{
      TREV(I)=TR*R(I)*DFA(I-1)+TW*W(I)*AGEL(I)+XTC(I)*AGC(I)-TW*AGPP(I)+TWP*AGPR(I);
      
   
  %@̑
      %  eGDP䗦
      XTINV(I)=(CAP(I+1)-CAP(I)+RDEP*CAP(I))/GDP(I);
      
      %@~
      SRATE(I)=(GDP(I)-AGC(I)-GCAG(I))/GDP(I);     
  end
  
  %**************************
  %@ŗivZpj
  %**************************
  for I=ISE:ITER1;
      X(I,2)=XTC(I)+(GCAG(I)+RDEBT(I)-TREV(I)-BOND(I))/AGC(I);      
  end
  for I=1:ISE-1;
      X(I,2)=XTC(I);
  end

%----------------------------------
%  {J䗦̐v
%----------------------------------
for I=ISE:ITER1;     
    X(I,1)=(1-SDRT)*(PASET(I)+FUND(I))/AGEL(I);    
end

%--------------------
%@
%--------------------
KOUNT=KOUNT+1

 DIF=0;
 for I=ISE:ITER1;
     DIF=DIF+abs(1-X(I,1)/OLDX(I,1));
     DIF=DIF+abs(1-X(I,2)/OLDX(I,2));       
 end
 DIF=DIF/(2*(ITER1-ISE))
 
 %--------------
 %@ϐ̒u
 %--------------
 for I=ISE:ITER1;
     OLDX(I,1)=0.5*(X(I,1)+OLDX(I,1));
     OLDX(I,2)=0.5*(X(I,2)+OLDX(I,2));
 end

end

%*****************************
%@[vI
%*****************************
for I=1:ISE-1;   
    OLDX(I,1)=SKL1;
    OLDX(I,2)=TC;
end


%-------------------------------------------------------
%@EQUIVTuvOiϕ̌vZpvOj
%-------------------------------------------------------

  %@ěp̌vZ
  
EPS=0.000001;
    for J=1:ITER1;
        UTIL(J)=0;
        if GAMMA==1;
            for K=1:IDIE;
                UTIL(J)=UTIL(J)+log(C(J,K))*(1+RHO)^(-(K-1));
            end
        else
            for K=1:IDIE;
                UTIL(J)=UTIL(J)+(C(J,K))^(1-GAMMA)/(1-GAMMA)*(1+RHO)^(-(K-1));
            end
        end
        
        EX1=0.3;
        EX2=3;
        Y=UDIF(EX1,UTIL(J),J);
        EVRT(J)=0;
        
        XX=1;
        while XX > EPS;
            EXM=(EX1+EX2)/2;            
            X=UDIF(EXM,UTIL(J),J);
            XX=Y*X;
            
            if XX > 0;
                EX1=EXM;
            else
                EX2=EXM;
            end
            
            XX=EX2-EX1;                   
        end
        
        EVRT(J)=EXM;
    end
    
    
I=ISE:ITER1-50;
subplot(2,2,1);
plot(I,SRATE(I)*100,'ko');
xlabel('');
ylabel('~%');

subplot(2,2,2);
plot(I,OLDX(I,1),'ko');
xlabel('');
ylabel('{J䗦');

subplot(2,2,3);
plot(I,OLDX(I,2)*100,'ko');
xlabel('');
ylabel('ŗ%');

subplot(2,2,4);
plot(I,EVRT(I),'ko');
xlabel('');
ylabel('ϕ(퐢=1)');









